// import { login, logout, getInfo } from '@/api/user'
// import { getToken, setToken, removeToken } from '@/utils/auth'
// import { resetRouter } from '@/router'

// const getDefaultState = () => {
//   return {
//     token: getToken(),
//     name: '',
//     avatar: ''
//   }
// }

// const state = getDefaultState()

// const mutations = {
//   RESET_STATE: (state) => {
//     Object.assign(state, getDefaultState())
//   },
//   SETTOKEN: (state, token) => {//保存tonken
//     state.token = token
//   },
//   SET_NAME: (state, name) => {
//     state.name = name
//   },
//   SET_AVATAR: (state, avatar) => {
//     state.avatar = avatar
//   }
// }

// const actions = {
//   login({ commit }, userInfo) {
//     const { user_name, password } = userInfo

//     alert(user_name + "," + password)
//     // return new Promise((resolve, reject) => {
//     //   login({ user_name: user_name.trim(), password: password }).then(response => {
//     //     const { data } = response
//     //     commit('SETTOKEN', data.token)//保存到store中
//     //     setToken(data.token)//保存到本地Cookies中
//     //     resolve()
//     //   }).catch(error => {
//     //     reject(error)
//     //   })
//     // })
//   },

//   // get user info
//   getInfo({ commit, state }) {
//     return new Promise((resolve, reject) => {
//       getInfo(state.token).then(response => {
//         const { data } = response

//         if (!data) {
//           return reject('Verification failed, please Login again.')
//         }

//         const { name, avatar } = data

//         commit('SET_NAME', name)
//         commit('SET_AVATAR', avatar)
//         resolve(data)
//       }).catch(error => {
//         reject(error)
//       })
//     })
//   },

//   // user logout
//   logout({ commit, state }) {
//     return new Promise((resolve, reject) => {
//       logout(state.token).then(() => {
//         removeToken() // must remove  token  first
//         resetRouter()
//         commit('RESET_STATE')
//         resolve()
//       }).catch(error => {
//         reject(error)
//       })
//     })
//   },

//   // remove token
//   resetToken({ commit }) {
//     return new Promise(resolve => {
//       removeToken() // must remove  token  first
//       commit('RESET_STATE')
//       resolve()
//     })
//   }
// }

// export default {
//   state,
//   mutations,
//   actions,
// }

import { getToken, setToken, removeToken, setUserInfo, removeUserInfo, getUserInfo } from "@/utils/auth"
import { operatorLogin, getOperatorPermission } from "@/api/user"

export default {
    namespaced: true,
    state: {
        token: getToken() || '',//从本地获得token信息
        userInfo: getUserInfo() || {},//从本地获得用户信息
        menuPermission: [],//页面权限
        btnPermission: [],//按钮权限
    },
    mutations: {
        UpdateToken(state, token) {//保存token
            state.token = token
            setToken(token)
        },
        RemoveToken(state) {//删除token
            state.token = ''
            removeToken()//清空本地token
        },
        UpdateUserInfo(state, userInfo) {
            state.userInfo = userInfo
            setUserInfo(userInfo)//将userInfo保存到本地
        },
        RemoveUserInfo(state) {//清空用户信息
            state.userInfo = {}
            removeUserInfo()//删除本地userInfo
        },
        setOperatorPermission(state, data) {
            state.menuPermission = data.menus
            state.btnPermission = data.btns
        },
        removeOperatorPermission(state) {
            state.menuPermission = []
            state.btnPermission = []
        }
    },
    actions: {
        async userLogin(context, data) {
            const res = await operatorLogin(data)//登录
            context.commit("UpdateToken", res.data.token)//调用mutation中的方法保存token
            context.commit("UpdateUserInfo", res.data)//调用mutation中的方法保存token
        },
        async getOperatorPermission(context) {//获得操作员的访问权限，包括页面和按钮访问权限
            const res = await getOperatorPermission()
            context.commit('setOperatorPermission', res.data)
            return res.data
        },
        logout(context) {//用户登出
            context.commit("RemoveToken")
            context.commit("RemoveUserInfo")
            context.commit("removeOperatorPermission")
        }
    },
    getters: {},
}